Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/etranzact/browser.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/etranzact/browser.py	(revision 15947)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/etranzact/browser.py	(revision 15999)
@@ -51,9 +51,11 @@
 
     def update(self):
-        # Already now it becomes an Etranzact payment. We set the net amount
-        # and add the gateway amount.
         if not webconnect_module_activated(
             self.context.__parent__.__parent__.year, self.context):
-            return _("Etranzact payments deactivated.")
+            self.flash(_('Forbidden'), type='danger')
+            self.redirect(self.url(self.context, '@@index'))
+            return 
+        # Already now it becomes an Etranzact payment. We set the net amount
+        # and add the gateway amount.
         if not self.context.r_company:
             self.context.net_amt = self.context.amount_auth
@@ -93,9 +95,11 @@
 
     def update(self):
-        # Already now it becomes an Etranzact payment. We set the net amount
-        # and add the gateway amount.
         if not webconnect_module_activated(
             self.context.student.current_session, self.context):
-            return _("Etranzact payments deactivated.")
+            self.flash(_('Forbidden'), type='danger')
+            self.redirect(self.url(self.context, '@@index'))
+            return
+        # Already now it becomes an Etranzact payment. We set the net amount
+        # and add the gateway amount.
         if not self.context.r_company:
             self.context.net_amt = self.context.amount_auth
@@ -135,6 +139,7 @@
         if not payoutlet_module_activated(
             self.context.student.current_session, self.context):
-            return
-        super(EtranzactEnterPinPageStudent, self).update()
+            self.flash(_('Forbidden'), type='danger')
+            self.redirect(self.url(self.context, '@@index'))
+            return
         # Already now it becomes an Etranzact payment. We set the net amount
         # and add the gateway amount.
@@ -159,6 +164,7 @@
         if not payoutlet_module_activated(
             self.context.__parent__.__parent__.year, self.context):
-            return
-        super(EtranzactEnterPinPageApplicant, self).update()
+            self.flash(_('Forbidden'), type='danger')
+            self.redirect(self.url(self.context, '@@index'))
+            return
         # Already now it becomes an Etranzact payment. We set the net amount
         # and add the gateway amount.
Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/interswitch/browser.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/interswitch/browser.py	(revision 15947)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/interswitch/browser.py	(revision 15999)
@@ -20,4 +20,5 @@
 import grok
 from kofacustom.nigeria.interswitch.browser import (
+    module_activated,
     InterswitchPaymentRequestWebservicePageApplicant,
     InterswitchPaymentRequestWebservicePageStudent,
@@ -64,4 +65,9 @@
 
     def update(self):
+        if not module_activated(
+            self.context.student.current_session, self.context):
+            self.flash(_('Forbidden'), type='danger')
+            self.redirect(self.url(self.context, '@@index'))
+            return
         error = self.init_update()
         if error:
@@ -158,4 +164,9 @@
 
     def update(self):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
+            self.flash(_('Forbidden'), type='danger')
+            self.redirect(self.url(self.context, '@@index'))
+            return
         error = self.init_update()
         if error:
Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/students/browser.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/students/browser.py	(revision 15947)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/students/browser.py	(revision 15999)
@@ -45,5 +45,6 @@
     NigeriaStudentBaseEditFormPage,
     NigeriaBedTicketAddPage,
-    NigeriaAccommodationManageFormPage
+    NigeriaAccommodationManageFormPage,
+    NigeriaAccommodationDisplayFormPage,
     )
 
@@ -92,4 +93,9 @@
     #            )
     #    return ()
+
+class CustomAccommodationDisplayFormPage(NigeriaAccommodationDisplayFormPage):
+    """ Page to view bed tickets.
+    """
+    with_hostel_selection = True
 
 class CustomAccommodationManageFormPage(NigeriaAccommodationManageFormPage):