Index: /main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser.py
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser.py	(revision 16002)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser.py	(revision 16003)
@@ -27,7 +27,8 @@
     IExtFileStore, IFileStoreNameChooser, IKofaUtils)
 from zope.formlib.textwidgets import BytesDisplayWidget
+from waeup.kofa.widgets.datewidget import FriendlyDatetimeDisplayWidget
 from waeup.kofa.utils.helpers import string_from_bytes, file_size
 from waeup.kofa.applicants.browser import (
-    ApplicantCheckStatusPage, ApplicantBaseDisplayFormPage,
+    ApplicantCheckStatusPage,
     AdditionalFile)
 from waeup.kofa.applicants.workflow import STARTED, PAID
@@ -58,4 +59,5 @@
     IFedexRequest,
     IRecruitment,
+    ICustomApplicantOnlinePayment,
     )
 
@@ -252,4 +254,5 @@
             form_fields = grok.AutoFields(IFedexRequest).omit(
                 'locked', 'suspended')
+            return form_fields
         if self.target is not None and self.target == 'rec':
             form_fields = grok.AutoFields(IRecruitment).omit(
@@ -343,5 +346,5 @@
             return '<br /><br />' + note
         if self.target is not None and self.target in (
-            'trans', 'cert', 'ver', 'send'):
+            'trans', 'cert', 'ver', 'send', 'fedex'):
             return
         if self.context.sex == 'm':
@@ -382,4 +385,7 @@
         elif self.target is not None and self.target == 'cert':
             form_fields = grok.AutoFields(ICertificateRequest).omit(
+                'locked', 'suspended')
+        elif self.target is not None and self.target == 'fedex':
+            form_fields = grok.AutoFields(IFedexRequest).omit(
                 'locked', 'suspended')
         else:
@@ -650,9 +656,43 @@
         return ''
 
+class ApplicantBaseDisplayFormPage(CustomApplicantDisplayFormPage):
+    grok.context(ICustomApplicant)
+    grok.name('base')
+
+    @property
+    def form_fields(self):
+        if self.context.__parent__.prefix in ('fedex',):
+            form_fields = grok.AutoFields(IFedexRequest).select(
+                'applicant_id', 'trans_id', 'email',)
+        else:
+            form_fields = grok.AutoFields(ICustomApplicant).select(
+                'applicant_id', 'reg_number', 'email', 'course1')
+        if self.context.__parent__.prefix in ('special',):
+            form_fields['reg_number'].field.title = u'Identification Number'
+            return form_fields
+        return form_fields
+
 class CustomExportPDFPaymentSlipPage(NigeriaExportPDFPaymentSlipPage):
+
+    form_fields = grok.AutoFields(ICustomApplicantOnlinePayment).omit(
+        'ac', 'provider_amt', 'gateway_amt', 'thirdparty_amt', 'p_item',
+        'p_split_data')
+    form_fields['creation_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
+    form_fields['payment_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
 
     @property
     def payment_slip_download_warning(self):
         return ''
+
+    def render(self):
+        if self.payment_slip_download_warning:
+            self.flash(self.payment_slip_download_warning, type='danger')
+            self.redirect(self.url(self.context))
+            return
+        applicantview = ApplicantBaseDisplayFormPage(self.context.__parent__,
+            self.request)
+        students_utils = getUtility(IStudentsUtils)
+        return students_utils.renderPDF(self,'payment_slip.pdf',
+            self.context.__parent__, applicantview, note=self.note)
 
 class CustomApplicantCheckStatusPage(ApplicantCheckStatusPage):
Index: /main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 16002)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 16003)
@@ -143,6 +143,6 @@
             elif self.applicant.__parent__.prefix == 'fedex':
                 provider_amt = 0.0
-                self.institution_acct = '1010041670'
-                self.institution_bank_id = '117'
+                self.institution_acct = '0001115694'
+                self.institution_bank_id = '10'
         xmldict = {}
         xmldict['detail_ref'] = self.context.p_id
@@ -178,5 +178,5 @@
 <item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
 <item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
-<item_detail item_id="3" item_name="FedEx" item_amt="%(fedex_amt)d" bank_id="117" acct_num="1010041670" />
+<item_detail item_id="3" item_name="FedEx" item_amt="%(fedex_amt)d" bank_id="10" acct_num="0001115694" />
 </item_details>
 </payment_item_detail>""" % xmldict