Index: main/kofacustom.dspg/trunk/src/kofacustom/dspg/applicants/browser.py
===================================================================
--- main/kofacustom.dspg/trunk/src/kofacustom/dspg/applicants/browser.py	(revision 16025)
+++ main/kofacustom.dspg/trunk/src/kofacustom/dspg/applicants/browser.py	(revision 16026)
@@ -170,5 +170,5 @@
         if self.context.special:
             return grok.AutoFields(ICustomSpecialApplicant)
-        if self.target == 'conv':
+        if self.target in ('conv', 'hndfincl', 'ndfincl'):
             form_fields = grok.AutoFields(ICustomSpecialApplicant)
             form_fields = form_fields.omit(
@@ -238,5 +238,5 @@
     @property
     def form_fields(self):
-        if self.target in ('conv', 'special'):
+        if self.target in ('conv', 'special', 'hndfincl', 'ndfincl'):
             form_fields = grok.AutoFields(ICustomSpecialApplicant)
             form_fields = form_fields.omit(
@@ -276,5 +276,5 @@
             form_fields['applicant_id'].for_display = True
             return form_fields
-        if self.target == 'conv':
+        if self.target in ('conv', 'hndfincl', 'ndfincl'):
             form_fields = grok.AutoFields(ICustomSpecialApplicant)
             form_fields = form_fields.omit(
@@ -317,5 +317,5 @@
             form_fields['applicant_id'].for_display = True
             return form_fields
-        if self.target == 'conv':
+        if self.target in ('conv', 'hndfincl', 'ndfincl'):
             form_fields = grok.AutoFields(ICustomSpecialApplicant)
             form_fields = form_fields.omit(
@@ -384,5 +384,6 @@
     @property
     def form_fields(self):
-        if self.context.__parent__.prefix in ('conv', 'special'):
+        if self.context.__parent__.prefix in (
+            'conv', 'special', 'hndfincl', 'ndfincl'):
             form_fields = grok.AutoFields(ICustomApplicant).select(
                 'applicant_id', 'reg_number', 'email')
@@ -406,5 +407,6 @@
         form_fields['creation_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
         form_fields['payment_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
-        if self.context.__parent__.__parent__.prefix in ('conv', 'special'):
+        if self.context.__parent__.__parent__.prefix in (
+            'conv', 'special', 'hndfincl', 'ndfincl'):
             form_fields = form_fields.omit('p_session')
         return form_fields
Index: main/kofacustom.dspg/trunk/src/kofacustom/dspg/applicants/utils.py
===================================================================
--- main/kofacustom.dspg/trunk/src/kofacustom/dspg/applicants/utils.py	(revision 16025)
+++ main/kofacustom.dspg/trunk/src/kofacustom/dspg/applicants/utils.py	(revision 16026)
@@ -54,4 +54,6 @@
         'special': ['Supplementary Payment', 'SP'],
         'conv': ['Convocation Pack Payment', 'CPP'],
+        'hndfincl': ['HND Final Clearance Pack Payment', 'HNDF'],
+        'ndfincl': ['ND Final Clearance Pack Payment', 'NDF'],
         }
 
Index: main/kofacustom.dspg/trunk/src/kofacustom/dspg/applicants/viewlets.py
===================================================================
--- main/kofacustom.dspg/trunk/src/kofacustom/dspg/applicants/viewlets.py	(revision 16025)
+++ main/kofacustom.dspg/trunk/src/kofacustom/dspg/applicants/viewlets.py	(revision 16026)
@@ -31,5 +31,5 @@
         if self.context.state in ('initialized', 'started', 'paid'):
             return
-        if self.context.__parent__.prefix == 'conv':
+        if self.context.__parent__.prefix in ('conv', 'hndfincl', 'ndfincl'):
             return
         return self.view.url(self.view.context, self.target)
Index: main/kofacustom.dspg/trunk/src/kofacustom/dspg/interswitch/browser.py
===================================================================
--- main/kofacustom.dspg/trunk/src/kofacustom/dspg/interswitch/browser.py	(revision 16025)
+++ main/kofacustom.dspg/trunk/src/kofacustom/dspg/interswitch/browser.py	(revision 16026)
@@ -510,5 +510,5 @@
             xmldict['institution_acct'] = '1015220292'
             xmldict['institution_bank_id'] = '117'
-        elif self.applicant.__parent__.prefix == 'conv':
+        elif self.applicant.__parent__.prefix in ('conv', 'hndfincl', 'ndfincl'):
             xmldict['institution_acct'] = '1012808851'
             xmldict['institution_bank_id'] = '117'