Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/browser.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/browser.py	(revision 16048)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/browser.py	(revision 16049)
@@ -43,8 +43,8 @@
     #UG_OMIT_MANAGE_FIELDS,
     #UG_OMIT_EDIT_FIELDS,
-    PG_OMIT_DISPLAY_FIELDS,
-    PG_OMIT_PDF_FIELDS,
-    PG_OMIT_MANAGE_FIELDS,
-    PG_OMIT_EDIT_FIELDS,
+    #PG_OMIT_DISPLAY_FIELDS,
+    #PG_OMIT_PDF_FIELDS,
+    #PG_OMIT_MANAGE_FIELDS,
+    #PG_OMIT_EDIT_FIELDS,
     )
 from kofacustom.iuokada.applicants.interfaces import (
@@ -78,4 +78,25 @@
     'aggregate')
 
+# PG has its own interface
+PG_OMIT_DISPLAY_FIELDS = OMIT_DISPLAY_FIELDS
+PG_OMIT_PDF_FIELDS = PG_OMIT_DISPLAY_FIELDS + ('phone',)
+PG_OMIT_MANAGE_FIELDS = (
+    'special_application',
+    'employer',
+    'emp_position',
+    'emp_start',
+    'emp_end',
+    'emp_reason',
+    'employer2',
+    'emp2_position',
+    'emp2_start',
+    'emp2_end',
+    'emp2_reason',
+    )
+PG_OMIT_EDIT_FIELDS = PG_OMIT_MANAGE_FIELDS + PG_OMIT_DISPLAY_FIELDS + (
+    'student_id', 'notice',
+    'screening_score', 'screening_venue',
+    'screening_date',)
+
 class CustomApplicantsContainerPage(ApplicantsContainerPage):
     """The standard view for regular applicant containers.
@@ -142,4 +163,8 @@
     """An applicant-centered edit view for applicant data.
     """
+
+    @property
+    def display_refereereports(self):
+        return True
 
     def display_fileupload(self, filename):
Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/interfaces.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/interfaces.py	(revision 16048)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/interfaces.py	(revision 16049)
@@ -30,4 +30,5 @@
 from waeup.kofa.applicants.interfaces import (
     contextual_reg_num_source, IApplicantBaseData)
+from waeup.kofa.refereeentries import RefereeEntryField
 from kofacustom.nigeria.applicants.interfaces import (
     LGASource, high_qual, high_grade, exam_types, DisabilitiesSource,
@@ -325,4 +326,19 @@
         )
 
+    nysc_number = schema.Int(
+        title = _(u'Nysc Number'),
+        required = False,
+        readonly = False,
+        )
+
+    referees = schema.List(
+        title = _(u'Referees'),
+        value_type = RefereeEntryField(),
+        required = False,
+        defaultFactory=list,
+        )
+
+ICustomPGApplicant[
+    'referees'].order =  INigeriaPGApplicant['emp2_reason'].order
 ICustomPGApplicant[
     'sponsor'].order =  ICustomPGApplicant['lga'].order
@@ -333,4 +349,6 @@
 ICustomPGApplicant[
     'lga'].order =  ICustomPGApplicant['nationality'].order
+ICustomPGApplicant[
+    'nysc_number'].order =  ICustomPGApplicant['nysc_year'].order
 
 class ICustomApplicant(ICustomUGApplicant, ICustomPGApplicant):
Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/utils.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/utils.py	(revision 16048)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/utils.py	(revision 16049)
@@ -59,7 +59,7 @@
         'form.applicant_id': _(u'Base Data'),
         'form.course1': _(u'Programmes/Courses Desired'),
-        'form.hq_type': _(u'Higher Education Record (Direct Entry and Transfer Applicants)'),
+        'form.hq_type': _(u'Highest Educational Record (Direct Entry and Transfer Applicants)'),
         'form.presently': _(u'Course or Programme Presently Attending'),
-        'form.nysc_year': _(u'NYSC Information'),
+        'form.nysc_year': _(u'NYSC Information/Exemption Certificate'),
         'form.employer': _(u'Employment History'),
         'form.jamb_subjects': _(u'JAMB Data (All Applicants)'),
@@ -70,5 +70,5 @@
         'form.fst_sit_fname': _(u'First Sitting Record'),
         'form.scd_sit_fname': _(u'Second Sitting Record'),
-        'form.referees': _(u'Referees'),
+        'form.referees': _(u'Referees (will be automatically invited by email after final submission)'),
         'form.parents_name': _(u'Parents / Guardian'),
         }
Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/locales/en/LC_MESSAGES/waeup.kofa.po
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/locales/en/LC_MESSAGES/waeup.kofa.po	(revision 16048)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/locales/en/LC_MESSAGES/waeup.kofa.po	(revision 16049)
@@ -121,2 +121,7 @@
 msgid "Balance Amount"
 msgstr "Custom/Balance Amount"
+
+msgid ""
+"Email Address (referees will be automatically invited by email after final "
+"submission of this form)"
+msgstr "Email Address"