Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/etranzact/browser.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/etranzact/browser.py	(revision 16105)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/etranzact/browser.py	(revision 16111)
@@ -275,13 +275,31 @@
         'IUO_SCHOOL_FEES_FIRST_INSTALLMENT': ('schoolfee40',),
         'IUO_SCHOOL_FEES_OTHER_INSTALLMENT': ('secondinstal',),
-        'IUO_TRANSCRIPT_FEE': ('transcript_overseas','transcript_local'),
+
+        'IUO_SUNDRY_FEES': ('combi',),
+
+        'IUO_MATRICULATION_FEE': ('matric',),
+        'IUO_LATE_REGISTRATION_FEE': ('late_registration',),
+        'IUO_WAEC/NECO_VERIFICATION_FEE': ('waecneco',),
+        'IUO_JAMB_VERIFICATION': ('jambver',),
+        'IUO_CONVOCATION_FEE': ('conv',),
+        'IUO_ALUMNI_FEE': ('alumni',),
+        'IUO_SCIENCE_BENCE_FEE': ('science',),
+        'IUO_LETTER_OF_IDENTIFICATION_FEE': ('lo_ident',),
+        'IUO_CHANGE_OF_COURSE_FEE': ('change_course',),
+        'IUO_IUITS_FEE': ('iuits',),
+        'IUO_FINES_FEE': ('fine',),
+        'IUO_PHARMACY_LAB_SUPPORT_FEE': ('pharmlab',),
+        'IUO_MAKEUP_FEE': ('resit1', 'resit2', 'resit3', 'resit4',
+                           'resit5', 'resit6', 'resit7', 'resit8',
+                           'resit9',),
+        'IUO_CLINICAL_FEE_MEDICAL_STUDENTS': ('clinical',),
+        'IUO_TRANSCRIPT_FEE_INTERNATIONAL': ('transcript_overseas',),
+        'IUO_TRANCRIPT_FEE_LOCAL': ('transcript_local',),
+        'IUO_CLEARANCE_FEE': ('clearance',),
+        'IUO_ID_CARD_FEE': ('id_card',),
         'IUO_REGISTRATION_FEE': ('registration',),
+        'IUO_DEVELOPMENT_FEE': ('develop',),
+        'IUO_MUNICIPAL_FEE': ('municipal_fresh','municipal_returning'),
+        'IUO_BOOK_DEPOSIT': ('book',),
         'IUO_PARENTS_CONSULTATIVE_FORUM_FEE': ('parentsconsult',),
-        'IUO_BOOK_DEPOSIT_FEE': ('book',),
-        'IUO_MATRICULATION_FEE': ('matric',),
-        'IUO_SUNDRY_FEES': ('late_registration',
-            'science','clinical','develop','municipal',
-            'alumni','conv','matric','waecneco','jambver','pharmlab','lo_ident',
-            'change_course','resit1','resit2','resit3','resit4','resit5',
-            'resit6','resit7','resit8','resit9','iuits','fine','combi'),
          }
Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/interfaces.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/interfaces.py	(revision 16105)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/interfaces.py	(revision 16111)
@@ -214,4 +214,10 @@
         default = 0.0,
         required = False,
+        )
+
+    id_card_fee = schema.Float(
+        title = _(u'Student ID Card Fee'),
+        default = 0.0,
+        required = True,
         )
 
Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/utils/utils.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/utils/utils.py	(revision 16105)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/utils/utils.py	(revision 16111)
@@ -69,4 +69,5 @@
         'resit8': '8 Make-Up Examination Courses',
         'resit9': '9 Make-Up Examination Courses',
+        'id_card': 'Student ID Card',
         }
 
@@ -113,4 +114,5 @@
         'resit8': '8 Make-Up Examination Courses',
         'resit9': '9 Make-Up Examination Courses',
+        'id_card': 'Student ID Card',
         }
 
@@ -138,4 +140,5 @@
         'iuits': 'IUITS Fee',
         'fine': 'Fine',
+        'id_card': 'Student ID Card',
         }
 
@@ -160,4 +163,5 @@
         'iuits': 'IUITS Fee',
         'fine': 'Fine',
+        'id_card': 'Student ID Card',
         }
 
@@ -195,4 +199,5 @@
         'resit8': '8 Make-Up Examination Courses',
         'resit9': '9 Make-Up Examination Courses',
+        'id_card': 'Student ID Card',
         }
 